// Empirical Example


// the identifier of neighborhood is variable     censusd  (within every site)
	//site is first sampling unit censusd is seond sampling unit
	//negighborhood is identified by round-site-censusd
// data used is RLMS data for rounds 5-16. After round 16 RLMS survey 


//PART 1: 
//create anonimization data
use data.dta , clear 

	keep site censusd family round
	replace censusd=-999 if censusd==.  
	bysort site censusd round: keep if _n==1   //neighbordoods
	set seed 1000
	gen counter=runiform()
	bysort id round (counter): gen neighborhood=_n
	bysort id round (counter): gen M=_N
	replace   neighborhood= neighborhood-1 if  neighborhood==M
	replace neighborhood=int((neighborhood-1)/2)
	keep site  round censusd neighborhood
	sort site  round censusd
	save k_anonin_neighborhoods.dta, replace
	 
 
  
 
// Part 2: create k-anonimity graphs  
 
 
use data.dta, clear
  
// create vars used in analysis from raw data
capture {
	    // household size
	egen hh_size=count(round), by(site censusd family round)
		//age
	gen age=inty-birthy
	keep if age>=18&age<=65 
 		//age of oldest memeber of houshold
	egen age_hh=max(age), by(site censusd family round)
 		//college degree
	gen college=0 if stins1!=.
	replace  college=1 if stins1<2.1&round>=15
	replace  college=1 if stins1<1.1&round<15
	replace  college=0 if   stinsu==2
	replace  college=1 if  stinsu==1
	replace college=0 if studew==2
	sort  idind round
	replace  college=college[_n-1] if college==.&idind==idind[_n-1]
		//income
	replace inclmo=inclmo/1000 if round<7.5
	gen logincome=log(1+inclmo)  
		//occupation
	gen ilo=int(ilopjb/1000)   
	}
	
 
keep if age==age_hh  //pick up head of households defined as oldest person 
keep age hh_size logincome college ilo site censusd family round gender id  //keep only vars used for analysis
xi i.ilo   //dummies for occupation
local varlist  "hh_size age logincome college _I* gender"
collapse  `varlist' id, by( site censusd family round)
for var   _I* : replace X=0 if X==.
 
 
// merge anonimiziation data and analysis
 
sort site round censusd
merge site round censusd using k_anonin_neighborhoods.dta 


  local varlist  "hh_size age logincome college _I* gender"

 capture gen cluster=.
//max number of hhs: 52 for all, 32 for all but mosckow
 foreach X of numlist  7	11	16	18	21	22	23	24	25	26	28	34	40	45	47	48	50	52	54	56	58	59	61	64	67	68	69	70	71	74	77 	78	86 {
	 foreach R of numlist 5/16{
		foreach N of numlist 0/25{
			 
				capture cluster kmeans `varlist'  if id==`X'&round==`R'&neighborhood==`N', k(2) name(cl_`X'`R'`N') 
				capture replace cluster=cl_`X'`R'`N'*1000000+`N'*10000+`X'*100+`R' if cluster==.
				capture drop cl_`X'`R'`N'			
			  
			
		}
	 }
	 
			 
 }
 
 
 
 
foreach X of varlist `varlist'{
	egen m`X'=mean(`X') , by (cluster)   //cluster  center
	egen sd`X'=sd(`X')
}
gen distance_to_center=0
foreach X of varlist   `varlist'{
	replace distance_to_center=distance_to_center+ ((`X' -m`X')^2)
}
replace distance=sqrt(distance_to_center)
xtile quantiles_d = distanc, nq(10)
 

keep cluster quantiles_d distance site censusd family round 
sort site censusd family round 
save distance_to_cluster_center_kanonimity.dta, replace

// Figure 6, 8, 10

foreach Q of numlist 9 5 1{
	use distance_to_cluster_center_kanonimity.dta, clear
	keep if quantiles_d<=`Q'
	bysort censusd  round cluster: gen n=_N
    egen n_max=max(n), by(cluster round)
	bysort cluster   round: keep if _n==_N
	lab var n_max "{&pi}N, {&theta}=0.`Q'"
	hist n_max   , saving(hist`Q'_kanonimity.gph , replace)
	
	 graph export hist`Q'_kanonimity.eps, replace
!epstopdf    hist`Q'_kanonimity.eps
}


//graph with distance
use distance_to_cluster_center_kanonimity.dta, clear

foreach Q of numlist 9 5 1{
 	egen diam`Q'=max(distance_to_c) if quantiles_d<=`Q' , by(censusd  round cluster)
    sum diam`Q' 
	local diametr`Q'=r(max)
}

clear 
set obs 3
gen alpha=.
gen theta=.
local n=1
foreach Q of numlist 9 5 1{
 	replace alpha=`diametr`Q'' in `n'
	replace theta=`Q'/10 in `n'
	local n=`n'+1
}
replace alpha=1/alpha
lab var alpha "{&alpha}N"
lab var theta "{&theta}"
  line theta alpha, saving(distance_to_center.gph , replace)
 graph export distance_to_center.eps, replace
 !epstopdf    distance_to_center.eps



 
 
 // Part 3. Figures 5 7 9
 
 
 
 use data.dta, clear
  
// create vars used in analysis from raw data
capture {
	    // household size
	egen hh_size=count(round), by(site censusd family round)
		//age
	gen age=inty-birthy
	keep if age>=18&age<=65 
 		//age of oldest memeber of houshold
	egen age_hh=max(age), by(site censusd family round)
 		//college degree
	gen college=0 if stins1!=.
	replace  college=1 if stins1<2.1&round>=15
	replace  college=1 if stins1<1.1&round<15
	replace  college=0 if   stinsu==2
	replace  college=1 if  stinsu==1
	replace college=0 if studew==2
	sort  idind round
	replace  college=college[_n-1] if college==.&idind==idind[_n-1]
		//income
	replace inclmo=inclmo/1000 if round<7.5
	gen logincome=log(1+inclmo)  
		//occupation
	gen ilo=int(ilopjb/1000)   
	}
	
 keep if age==age_hh  //pick up head of households defined as oldest person 
 
 keep age hh_size logincome college ilo site censusd family round gender id  //keep only vars used for analysis
 
 xi i.ilo   //dummies for occupation
 
local varlist  "hh_size age logincome college _I* gender"
collapse  `varlist' id, by( site censusd family round)
for var   _I* : replace X=0 if X==.
 
  
 
 gen cluster=.
//max number of hhs: 52 for all, 32 for all but mosckow
 foreach X of numlist 7	11	16	18	21	22	23	24	25	26	28	34	40	45	47	48	50	52	54	56	58	59	61	64	67	68	69	70	71	74	77	78	86 {
	 foreach R of numlist 5/20{
		capture {
			cluster kmeans `varlist'  if id==`X'&round==`R', k(10) name(cl_`X'`R') 
			replace cluster=cl_`X'`R'*10000+`X'*100+`R' if cluster==.
			drop cl_`X'`R'
			
		}
	 }
 }
foreach X of varlist `varlist'{
	egen m`X'=mean(`X') , by (cluster)   //cluster  center
	egen sd`X'=sd(`X')
}
gen distance_to_center=0
foreach X of varlist   `varlist'{
	replace distance_to_center=distance_to_center+ ((`X' -m`X')^2)
}
replace distance=sqrt(distance_to_center)
xtile quantiles_d = distanc, nq(10)
 

keep cluster quantiles_d distance site censusd family round 
sort site censusd family round 
save distance_to_cluster_center.dta, replace

//Figures 5, 7, 9
foreach Q of numlist 9 5 1{
	use distance_to_cluster_center.dta, clear
	keep if quantiles_d<=`Q'
	bysort censusd  round cluster: gen n=_N
    egen n_max=max(n), by(cluster round)
	bysort cluster   round: keep if _n==_N
	lab var n_max "{&pi}N, {&theta}=0.`Q'"
	hist n_max   , saving(hist`Q'.gph , replace)
}


