local file1 "Results/Table1.xls"

use RLMS_child.dta, clear
 
 
drop if age>=15   // keep if  age   14 or less
 
 
 // Noke: in this do file distance to inferred clusters dta files come from do -file-figures5678910.do
 
 
 replace censusd=-999 if censusd==. 
sort site censusd family round 
merge m:1 site censusd family round  using distance_to_cluster_center.dta, keep(2 3) nogen
 

//create variables
gen female= gender-1
for var  orthodox muslim  neighborhood_muslim neighborhood_orthodox neighborhood_logincome sharemuslim2002  college  logincome city age loggrp_pc: gen femaleX=female*X
gen attend_school=2-inschl 
lab var attend_school " attending  school"
replace grades=wgrade-1 if grades==.
replace grades=0 if grades<0
rename grades grades_completed
gen body_mass =wtself/((htself/100)^2)
replace body_mass =weight/((heigh/100)^2) if body_mass==.
gen GPA=(6-prgres)*5/6
replace hwphrs =0 if hwphrs ==.&hwphrs ==0
replace intrnt=intrne  if intrnt==.
xi i.round 
 
 //two sets of controls
 local controls1 "femalemuslim femaleorthodox  female orthodox muslim college  logincome city age  femalecollege  femalelogincome femalecity   "
 local controls2 "femalemuslim femaleorthodox femaleneighborhood_muslim  femaleneighborhood_orthodox female orthodox muslim college  logincome city age  femalecollege  femalelogincome femalecity  neighborhood_muslim neighborhood_orthodox neighborhood_logincome  "
 
  	 local replace "replace"  

	 //loop over set of controls
	 
 foreach T of numlist 1/2 {   //tables in the paper (1) Own (2)  Own+ Neighborhood effect , Base specification
 		 reg grades_completed  `controls`T''   if age>=7  
		 outreg2 using "`file1'"  ,   drop( _I*) bdec(4) se  bracket `replace' addtext("Model", "Base")
		 local replace "append"
   }
 
   
foreach T of numlist 1/2 {   //tables in the paper (1) Own (2)  Own+ Neighborhood effect, Infer neighborhood
 		 reg grades_completed  `controls`T''   if age>=7 &quantiles_d<9
		 outreg2 using "`file1'"  ,   drop( _I*) bdec(4) se  bracket `replace' addtext("Model", "Infer neighborhood")
		 local replace "append"
   }
   

drop  cluster quantiles_d distance    
sort site censusd family round 
merge m:1 site censusd family round  using distance_to_cluster_center_kanonimity.dta, keep(2 3)  
 
   foreach T of numlist 1/2 {   //tables in the paper (1) Own (2)  Own+ Neighborhood effect, Infer neighborhood kanonim
 	 // Education
 		 reg grades_completed  `controls`T''   if age>=7 &quantiles_d<9
		 outreg2 using "`file1'"  ,   drop( _I*) bdec(4) se  bracket `replace' addtext("Model", "Infer neighborhood kanonim")
		 local replace "append"
	 
   }
    
